/* Built-in Functions File: this mostly just an adaptation layer for old code */

#include "config.h"

#include <math.h>
#ifdef HAVE_COMPLEX_H
#include <complex.h>
#endif

#include "bifuncs.h"
#include "message.h"
#include "eval_context.h"
#include "types/function.h"
#include "types/real.h"
#include "types/variable.h"

#include "types/int.h"
#include "types/nxp_string.h"

#include "element_type.h"


NxpElement* nxp_function_call_x(char* name, ...)
{
    va_list ap;
    NxpElement *func, *el;
    NxpElement *args;
    NxpIdentifier *ident;

    args = nxp_element_list_new();

    va_start(ap, name);
    while ((el = va_arg(ap, NxpElement*)))
	nxp_element_list_append(args, el);
    va_end(ap);
    
    ident = nxp_identifier_new();
    nxp_identifier_append_separator(ident);
    nxp_identifier_append_component(ident, name);
    func = nxp_element_function_new(ident, args, NULL);
    NXP_ELEMENT_UNREF(args);
    nxp_identifier_unref(ident);
    return func;
}



/* If the function acts like a constant, call this function
   to calculate it's derivate */
NxpElement* nxp_bifunc_derive_constant(NxpIdentifier *ident, GSList* args)
{
    return nxp_element_real_new(0);
}



