/* -*- Mode: C; c-file-style: "bsd"; -*- */

/* Variable number relation */

#include <math.h>

#include "list.h"
#include "tree.h"
#include "number.h"
#include "errors.h"
#include "op_bindings.h"
#include "types_misc.h"
#include "i18n.h"

static NxpElement* mult(NxpOp op, NxpElement *a, NxpElement *b, 
			NxpEvalContext *context, GError **error) {
    g_return_val_if_fail(NXP_ELEMENT_NUMBER(a), NULL);
    NxpElement *retval, *tmp;
    GSList *lst = NXP_ELEMENT_LIST(b)->list, *l;

    retval = nxp_element_list_new();

    for (l = lst; l; l = l->next) {
	tmp = nxp_element_tree_simplify_op(NXP_OP_STAR, a, l->data, context, error);
	nxp_element_list_append(retval, tmp);
	NXP_ELEMENT_UNREF(tmp);
    }
    return retval;
}

#define BIND_L(op,simp)    nxp_bind_operator_function (op, 		\
  				NXP_ELEMENT_TYPE_NUMBER, NXP_ELEMENT_TYPE_LIST, \
  				NULL,  			\
  				simp, 			\
  				NXP_OP_BIND_SYMMETRIC, \
				NULL); 

#define BIND_L_N(op,simp)    nxp_bind_operator_function (op, 			\
  				NXP_ELEMENT_TYPE_VARIABLE, NXP_ELEMENT_TYPE_NUMBER, \
  				NULL,  			\
  				simp, 			\
  				0, \
				NULL); 

#define BIND_N_L(op,simp)    nxp_bind_operator_function (op, 			\
  				NXP_ELEMENT_TYPE_NUMBER, NXP_ELEMENT_TYPE_VARIABLE, \
  				NULL,  			\
  				simp, 			\
  				0, \
				NULL); 

void nxp_element_list_number_operator_init(void)
{
    BIND_L(NXP_OP_STAR,mult);
//    BIND_V_N(NXP_OP_MINUS,sub_v_n);
//    BIND_N_V(NXP_OP_MINUS,sub_n_v);

//    BIND_T(NXP_OP_PLUS,add);
//    BIND_T_N(NXP_OP_MINUS,sub_v_n);
//    BIND_N_T(NXP_OP_MINUS,sub_n_v);
    
//    BIND_V(NXP_OP_STAR,mult);
    //NXP_OP_MINUS
//    BIND_V_N(NXP_OP_SLASH, divide_by_number);
//    BIND_N_V(NXP_OP_SLASH, divide_by_var);
//    BIND_V_N(NXP_OP_HAT, simplify_hat);
//    BIND_V(NXP_OP_EQ2, eq);
//    BIND_V(NXP_OP_EXCL_EQ, eq);

    //NXP_OP_MINUS_LEFT
    //NXP_OP_MINUS
    //NXP_OP_DOT3
    //NXP_OP_PLUS2_LEFT
    //NXP_OP_MINUS2_LEFT
    //NXP_OP_PLUS2_RIGHT
    //NXP_OP_MINUS2_RIGHT
    //NXP_OP_GT
    //NXP_OP_LT
    //NXP_OP_GE_EQ
    //NXP_OP_LT_EQ
    //NXP_OP_ExCL_EQ
    //NXP_OP_SLASH_BSLASH
    //NXP_OP_BSLASH_SLASH
    //NXP_TILDE_LEFT
    //NXP_EXCL_RIGHT
    //NXP_OP_EQ
    //NXP_OP_COLON_EQ
}
