/* -*- Mode: C; c-file-style: "stroustrup"; -*- */

#include <stdio.h>
#include <math.h>
#include "r.h"
#include "int.h"
#include "real.h"
#include "message.h"
#include "op_bindings.h"
#include "types_misc.h"
#include "errors.h"
#include "parser/plugins.h"
#include "i18n.h"


static NxpElementTypeInfo *typeinfo = NULL;

nxp_real_t nxp_element_r_get_value_as_double(NxpElementR *self)
{
    g_return_val_if_fail(NXP_ELEMENT_R_TYPE_INFO(self)->get_value_as_double, 0);
    return NXP_ELEMENT_R_TYPE_INFO(self)->get_value_as_double(self);
}

nxp_int_t nxp_element_r_get_value_as_int(NxpElementR *self)
{
    g_return_val_if_fail(NXP_ELEMENT_IS_R((NxpElement *)self), FALSE);
    return NXP_ELEMENT_R_TYPE_INFO(self)->get_value_as_int(self);
}

NxpElementType nxp_element_r_get_type(void)
{
    static NxpElementType nxp_element_type_r = 0;

    if (nxp_element_type_r == 0) {
	nxp_element_type_r = nxp_element_next_type();
	typeinfo = nxp_element_type_register_info(
		nxp_element_type_r, /* type to declare */
		sizeof(NxpElementRTypeInfo), /* size of our typeinfo */
		NXP_ELEMENT_TYPE_NUMBER,/* types from that it comes : here, NUMBER */
		sizeof(NxpElementNumberTypeInfo)); /* size of the parent typeinfo */
    }
    return nxp_element_type_r;
}

void nxp_element_r_type_init()
{
    NxpElementRTypeInfo *r_typeinfo;
    NxpElementNumberTypeInfo *nb_typeinfo;
    typeinfo = nxp_element_type_get_info(nxp_element_r_get_type());
    r_typeinfo = (NxpElementRTypeInfo *)typeinfo;
    nb_typeinfo = (NxpElementNumberTypeInfo *)typeinfo;
    typeinfo->name = g_strdup("r");
    typeinfo->eval_func = NULL;
    typeinfo->simplify_func = NULL;
    typeinfo->str_func = NULL;
    typeinfo->repr_func = NULL;
    typeinfo->truth_func = NULL;
    r_typeinfo->get_value_as_double = NULL;
    r_typeinfo->get_value_as_int = NULL;
}
